## interaction de base : selection
## P. Cubaud <cubaud@cnam.fr>

N=10

class Truc():
  def __init__(self,i,j):
    self.x=30+width*i/N
    self.y=30+height*j/N
    if random(0,1)<0.4:
        self.alarm = True
    else:
        self.alarm = False
    self.ident=str(i)+":"+str(j)
  def draw(self):
    noStroke()
    if self.alarm:
        fill(200,50,10)
    else:
        fill(50,200,10)
    ellipse(self.x,self.y,width/N-3,width/N-3)
  def refresh(self):
    if random(0,1)<0.4:
        self.alarm = True
    else:
        self.alarm = False
  def rollover(self,x,y):
    dist2 = (x-self.x)*(x-self.x)+(y-self.y)*(y-self.y)
    return dist2 < (width/N/2)*(width/N/2)

def setup():
    global lestrucs
    size(600,600) 
    lestrucs = []
    for i in range(N):
        for j in range(N):
            lestrucs.append(Truc(i,j))

def draw():
    ## dessin du pavage
    background(250)
    for k in range(N*N):
        lestrucs[k].draw()
    ## recherche du truc survole par la souris
    selection()

def keyPressed():
    if key == 's':
        saveFrame("exo2####.png")
    if key == ' ':
        for k in range(N*N):
            lestrucs[k].refresh()

def selection():
    k=0
    found=False
    while not found and k < N*N:
        found = lestrucs[k].rollover(mouseX,mouseY)
        k += 1
    if found:
        fill(0)
        textSize(80)
        text(lestrucs[k-1].ident,width/2,height/2)
        
    
