## carte de France avec les donnees du TP2
## P. Cubaud <cubaud@cnam.fr>

class Truc():
  def __init__(self,px,py,pident):
    self.x=px
    self.y=py
    self.ident=pident
    self.refresh()
  def draw(self):
    noStroke()
    if self.alarm:
        fill(200,50,10)
    else:
        fill(50,200,10)
    ellipse(self.x,self.y,30,30)
  def refresh(self):
    if random(0,1)<0.4:
        self.alarm = True
    else:
        self.alarm = False
  def rollover(self,x,y):
    dist2 = (x-self.x)*(x-self.x)+(y-self.y)*(y-self.y)
    return dist2 < 15*15

def setup():
    global lestrucs
    size(600,600)
    communes = loadTable("communes100.csv","header")  
    lestrucs = []
    for row in communes.rows():
        longit = row.getFloat("longitude")
        latit = row.getFloat("latitude")
        ident = row.getString("nom")
        x=map(longit,-5,9,0,width)
        y=map(latit,41,52,height,0)
        lestrucs.append(Truc(x,y,ident))

def draw():
    ## dessin du pavage
    background(250)
    for k in range(len(lestrucs)):
        lestrucs[k].draw()
    ## recherche du truc survole par la souris
    selection()

def selection():
    k=0
    found=False
    while not found and k < len(lestrucs):
        found = lestrucs[k].rollover(mouseX,mouseY)
        k += 1
    if found:
        fill(0)
        textSize(80)
        text(lestrucs[k-1].ident,10,height-10)
        
def mousePressed():
    ## recherche du truc concerné
    k=0
    found=False
    while not found and k < len(lestrucs):
        found = lestrucs[k].rollover(mouseX,mouseY)
        k += 1
    ## action sur le truc
    if found:
      lestrucs[k-1].alarm = False